---
title: 'RTCPeerConnection: negotiationneeded event'
slug: Web/API/RTCPeerConnection/negotiationneeded_event
tags:
  - API
  - Event
  - Negotiation
  - RTCPeerConnection
  - Reference
  - SDP
  - Signaling
  - WebRTC
  - WebRTC API
  - negotiationneeded
  - rtc
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">A <code><strong>negotiationneeded</strong></code> event is sent to the {{domxref("RTCPeerConnection")}} when negotiation of the connection through the signaling channel is required.</span> This occurs both during the initial setup of the connection as well as any time a change to the communication environment requires reconfiguring the connection.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCPeerConnection.onnegotiationneeded")}}</td>
  </tr>
 </tbody>
</table>

<p>The <code>negotiationneeded</code> event is first dispatched to the {{domxref("RTCPeerConnection")}} when media is first added to the connection. This starts the process of {{Glossary("ICE")}} negotiation by instructing your code to begin exchanging ICE candidates through the signaling server. See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling", "Signaling transaction flow")}} for a description of the signaling process that begins with a <code>negotiationneeded</code> event.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, we use {{domxref("EventTarget.addEventListener", "addEventListener()")}} to create an event handler for <code>negotiationneeded</code>. Its role is to create an {{Glossary("SDP")}} offer and send it through the signaling channel to the remote peer.</p>

<pre class="brush: js">pc.addEventListener("negotiationneeded", ev =&gt; {
  pc.createOffer()
  .then(offer =&gt; return pc.setLocalDescription(offer))
  .then(() =&gt; sendSignalingMessage({
    type: "video-offer",
    sdp: pc.localDescription
  }))
  .catch(err =&gt; {
    /* handle error */
  );
}, false);
</pre>

<p>After creating the offer, the local end is configured by calling {{domxref("RTCPeerConnection.setLocalDescription()")}}; then a signaling message is created and sent to the remote peer through the signaling server, to share that offer with the other peer. The other peer should recognize this message and follow up by creating its own {{domxref("RTCPeerConnection")}}, setting the remote description with {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}, and then creating an answer to send back to the offering peer.</p>

<p>You can also set an event handler for the <code>negotiationneeded</code> event by assigning the event handler function to the {{domxref("RTCPeerConnection.onnegotiationneeded")}} property:</p>

<pre class="brush: js">pc.onnegotiationneeded = ev =&gt; {
  pc.createOffer()
  .then(offer =&gt; return pc.setLocalDescription(offer))
  .then(() =&gt; sendSignalingMessage({
    type: "video-offer",
    sdp: pc.localDescription
  }))
  .catch(err =&gt; {
    /* handle error */
  );
};
</pre>

<p>For a more detailed example, see {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling", "Starting negotiation")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#event-negotiation', 'negotiationneeded') }}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.negotiationneeded_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
</ul>
